// Code automatically generated by "Generate_Cone_Mapping_Model" script by Jolyon Troscianko

//Model fits:
//swR2 0.99966383995596
//lwR2 0.999866093413636
//rodR2 0.999489296934988

// Modelled based on Natural Spectra 400-700 database, containing 3139 spectra.

// Generated: 2015/5/17   9:15:44


import ij.*;
import ij.plugin.filter.PlugInFilter;
import ij.process.*;

public class D7000_Nikkor_105mm_Pollack_D65 implements PlugInFilter {

ImageStack stack;
	public int setup(String arg, ImagePlus imp) { 
	stack = imp.getStack(); 
	return DOES_32 + STACK_REQUIRED; 
	}
public void run(ImageProcessor ip) {

float[] vR;
float[] vG;
float[] vB;
int w = stack.getWidth();
int h = stack.getHeight();
int dimension = w*h;

float[] sw = new float[dimension];
float[] lw = new float[dimension];
float[] rod = new float[dimension];

vR = (float[]) stack.getPixels(1);
vG = (float[]) stack.getPixels(2);
vB = (float[]) stack.getPixels(3);

for (int i=0;i<dimension;i++) {
sw[i] = (float) ( 11.2837867411232 + vR[i] * -0.00612639302180127 + vG[i] * -0.0921988508679037 + vB[i] * 1.08868694206719 + vR[i]*vG[i] * -2.81981672920286e-07 + vR[i]*vB[i] * 1.27055332344145e-08 + vG[i]*vB[i] * -4.29512556569778e-07 + vR[i]*vG[i]*vB[i] * 1.3129858573511e-11);
lw[i] = (float) ( -17.3220991266698 + vR[i] * -0.1687363880117 + vG[i] * 0.909710916470307 + vB[i] * 0.24786301049987 + vR[i]*vG[i] * -2.02861660911468e-07 + vR[i]*vB[i] * 8.25232052076577e-07 + vG[i]*vB[i] * 8.51047509620092e-08 + vR[i]*vG[i]*vB[i] * -8.38114966440038e-12);
rod[i] = (float) ( -25.2024609585824 + vR[i] * -0.163005985207044 + vG[i] * 0.582765669018155 + vB[i] * 0.565204833597946 + vR[i]*vG[i] * -1.47363270175611e-07 + vR[i]*vB[i] * 1.23510286752307e-06 + vG[i]*vB[i] * 1.25869349396112e-07 + vR[i]*vG[i]*vB[i] * -1.53871080301447e-11);
}

ImageStack outStack = new ImageStack(w, h);
outStack.addSlice("sw", sw);
outStack.addSlice("lw", lw);
outStack.addSlice("rod", rod);
new ImagePlus("Output", outStack).show();

}
}
